<template>
	<div class="flex-col md:rounded-lg lg:rounded bg-white px-4 md:px-6 lg:px-10 py-6 lg:py-10 mb-2">
		<MkStepProgress
			id="shipping_method_step"
			:step-title="page.shippingmethod"
			:step-number="stepNumber"
			:class-active="stepsCompleted === 3 ? 'active' : ''"
		/>
		<ValidationObserver v-if="stepsCompleted === 3" ref="shipping_method_validation_observer">
			<MkSuccessMessage v-if="success" class="mt-6 md:mt-8 mb-6 md:mb-4 lg:mb-6" />
			<MkInfoMessage
				v-if="page && value.method && value.method.title.includes('Ground') && value.method.price == '0'"
				:info-obj="{
					type: 'info',
					msg: page.freegroundmessage,
					class: 'bg-success rounded-md mt-6 mb-6 md:mt-8 md:mb-8',
				}"
			/>
			<MkListRecord
				v-if="shippingMethodsList.length > 0"
				:rules="shippingEnabled ? 'required' : ''"
				class="md:mt-8 mt-6"
				:disabled="!shippingEnabled"
				:contents="shippingMethodsList"
				:selected="value['method']['title']"
				@selected="updateShippingMethod($event)"
			/>
			<div class="flex justify-center items-center mt-8 lg:mt-10 mb-2 md:mb-0">
				<MkPrimaryButton
					ref="next_button"
					:disabled="!value['method']"
					btn-class="min-w-150 py-2 h-10"
					:loading="loading"
					button-title="Next"
					font-size="text-xl"
					@click="saveShippingMethod()"
				/>
			</div>
		</ValidationObserver>
	</div>
</template>
<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkSuccessMessage from '~/components/D2C/atoms/MkSuccessMessage.vue';
import MkInfoMessage from '~/components/D2C/atoms/MkInfoMessage.vue';
import MkListRecord from '~/components/D2C/organisms/MkListRecord/MkListRecord.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
export default {
	name: 'MkCheckoutShippingMethod',
	components: {
		MkStepProgress,
		MkSuccessMessage,
		MkInfoMessage,
		ValidationObserver,
		MkListRecord,
		MkPrimaryButton,
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: 1,
		},
		value: {
			type: Object,
			default: () => {},
		},
		page: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			loading: false,
			stepNumber: 3,
			success: false,
			warning: false,
			shippingEnabled: true,
			$shippingMethods: {},
			shippingMethodsList: [],
		};
	},
	computed: {
		...mapState(['currencyDisplay', 'isEurope']),
		...mapState('CHECKOUT_STORE', ['SHIPPING_METHODS']),
	},
	watch: {
		SHIPPING_METHODS: {
			deep: true,
			handler() {
				this.listHandel();
			},
		},
	},
	mounted() {
		// await this.$store.dispatch('CHECKOUT_STORE/GET_SHIPPING_METHODS');
		this.listHandel();
		this.$root.$utility.fieldFocus(this, 'next_button');
	},
	methods: {
		async saveShippingMethod() {
			try {
				const isValidForm = await this.$refs.shipping_method_validation_observer.validate();
				if (isValidForm) {
					this.loading = true;
					await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', {
						action: 'SET_SHIPPING_METHOD',
						shippingMethod: {
							cost: this.value.method.price,
							name: this.value.method.name,
						},
					});
					this.loading = false;
					this.$emit('completedstep', this.value);
				}
			} catch (error) {
				this.warning = true;
			}
		},
		updateForm(fieldName, value) {
			this.$set(this.value, fieldName, value);
			this.$emit('input', this.value);
		},
		updateShippingMethod(value) {
			this.updateForm('method', value);
		},
		listHandel() {
			let $shippingMethods = [];
			const $freight = this.SHIPPING_METHODS;
			if ($freight.length > 0) {
				$shippingMethods = [];
				for (let i = 0; i < $freight.length; i++) {
					$shippingMethods.push({
						title: $freight[i].displayName,
						description: `${$freight[i].duration} business ${$freight[i].duration !== '1' ? 'days' : 'day'}`,
						labeldescription: `${$freight[i].duration.replace('-', ' to ')} business ${
							$freight[i].duration !== '1' ? 'days' : 'day'
						}`,
						value: this.isEurope && $freight[i].cost === '0' ? 'Free' : `${this.currencyDisplay}${$freight[i].cost}`,
						name: $freight[i].serviceType,
						price: `${$freight[i].cost}`,
					});
				}
			}
			this.$shippingMethods = $shippingMethods;
			if (!this.value.method.title) {
				const selectedShipping = this.$shippingMethods.find((data) => data.name === 'FEDEX_GROUND');
				if (selectedShipping !== undefined) {
					this.updateShippingMethod(selectedShipping);
				}
			}
			this.shippingMethodsList = $shippingMethods;
		},
	},
};
</script>
